/**
 * -------------------------------------------------------- *
 * ----------------- КЛЮЧЕВОЕ СЛОВО THIS ------------------ *
 * -------------------------------------------------------- *
 *                  зависит от контекста                    *
 * -------------------------------------------------------- *
 */
let user = { name: "Ваня" };
let admin = { name: "Петя" };

function say_hi() {
    // эта строчка будет работать по разному 
    // в зависимости от объекта
    console.log(this.name + ", Hi!");
}

// используем нашу функцию в качестве
// методов каждого из объектов
user.say = say_hi;
admin.say = say_hi;

// вызовем методы каждого из объектов
user.say(); // Ваня, Hi!
admin.say(); // Петя, Hi!